#include "PBS_KeywordTable.h"


int main ()
{
char keys[6150][28];
for(int i=0; i<6150; i++) sprintf(keys[i], "Key%04i", i+1);

PBS_KeywordTable keyTable;
PBS_KeySet       keySet(keyTable);
for(int i=0; i<6150; i++) 
	{
	unsigned keyValue = keyTable.addKeyword(keys[i]);
	keySet.addKey(keyValue);
	if(i%2==0) keySet.delKey(keyValue-1);
	}
// keyTable.asciiDump();
// keySet.asciiDump();


PBS_KeySet keySet1(keyTable);
PBS_KeySet keySet2(keyTable);

keySet1.addKey(keyTable.getKey("Key0001"));
keySet1.addKey(keyTable.getKey("Key0002"));
keySet1.addKey(keyTable.getKey("Key0003"));
keySet2.addKey(keyTable.getKey("Key0001"));
keySet2.addKey(keyTable.getKey("Key0002"));
keySet2.addKey(keyTable.getKey("Key0003"));

int result = PBS_KeySet::compare(keySet1, keySet2);
fprintf(stdout, "KeySets 1 and 2 should be equal to  - KeySet 1 is %s Key Set 2\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");

keySet2.addKey(keyTable.getKey("Key0004"));
result = PBS_KeySet::compare(keySet1, keySet2);
fprintf(stdout, "KeySets 1 should be less than 2     - KeySet 1 is %s Key Set 2\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");
result = PBS_KeySet::compare(keySet2, keySet1);
fprintf(stdout, "KeySets 2 should be greater than 1  - KeySet 2 is %s Key Set 1\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");

keySet1.addKey(keyTable.getKey("Key0005"));
result = PBS_KeySet::compare(keySet1, keySet2);
fprintf(stdout, "KeySets 1 should be greater than 2  - KeySet 1 is %s Key Set 2\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");
result = PBS_KeySet::compare(keySet2, keySet1); 
fprintf(stdout, "KeySets 2 should be greater than 1  - KeySet 2 is %s Key Set 1\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");

keySet1.addKey(keyTable.getKey("Key0004"));
result = PBS_KeySet::compare(keySet1, keySet2);
fprintf(stdout, "KeySets 1 should be greater than 2  - KeySet 1 is %s Key Set 2\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");
result = PBS_KeySet::compare(keySet2, keySet1);
fprintf(stdout, "KeySets 2 should be less than 1     - KeySet 2 is %s Key Set 1\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");

keySet2.addKey(keyTable.getKey("Key0005"));
result = PBS_KeySet::compare(keySet1, keySet2);
fprintf(stdout, "KeySets 1 should be equal to 2      - KeySet 1 is %s Key Set 2\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");
result = PBS_KeySet::compare(keySet2, keySet1);
fprintf(stdout, "KeySets 2 should be equal to 1      - KeySet 2 is %s Key Set 1\n", result==0?"EQUALTO":result<0?"GREATER THAN":"LESS THAN");

}
