#include <PBS_Server.h>

const char * msg_daemonname = SetLogLocal("testUnderlord");

int main ( int argc, char ** argv)
{
int connID;

if(argc<2)
	{
	fprintf(stdout, "Format is : dumpQueues [server] <queue1> <queue2> ...\n\n");
	}
else if((connID = pbs_connect(argv[1]))<=0)
	{
	fprintf(stdout, "%s does not appear to be a valid server\n", argv[1]);
	}
else	{
	PBS_Server server(connID);
	
	if(argc==2)
		{
		PBS_QueueList & queue = server;
		queue.asciiDump();
		}
	else for(int i=0; i<argc; i++)
		{
		PBS_Queue * queue = server.getQueue(argv[i]);
		if(queue) queue->asciiDump();
		}
		
	pbs_disconnect(server.getConnectionID());
	}
return 0;
}
